/***********************************************************************/
/*                                                                     */
/*  FILE        :SH7262_SPDIF.c                                        */
/*  DATE        :Mon, May 24, 2010                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :SH72620                                               */
/*                                                                     */
/*  This file is generated by Renesas Project Generator (Ver.4.16).    */
/*                                                                     */
/***********************************************************************/

/*=== CN[h ===*/
#include "iodefine.h"

//#include "typedefine.h"
#ifdef __cplusplus
//#include <ios>                        // Remove the comment when you use ios
//_SINT ios_base::Init::init_cnt;       // Remove the comment when you use ios
#endif

void level(unsigned short *lev,unsigned short *peak );
void main(void);
#ifdef __cplusplus
extern "C" {
void abort(void);
}
#endif


/*
	`lXe[^Xrbgf[^
		bit31-30 : 0 ----------------- Reserved
		bit29-28 : B'10 -------------- NbNx:x[h(}50ppm)
		bit27-24 : B'0010 ------------ g:48kHz
		         : B'0000 ------------ g:44.1kHz
		         : B'0011 ------------ g:32kHz
		bit23-20 : B'1000 ------------ `l
		         : B'0100 ------------ E`l
		bit19-16 : B'0000 ------------ Mԍ:Don't care
		bit15-8  : B'00000000 -------- JeS[R[h:2`lėptH[}bg
		bit7-6   : B'00 -------------- [h:[h0
		bit5     : 0 ----------------- `l:2`l
		bit4-3   : B'00 -------------- vGt@VX:Ȃ
		bit2     : 0 ----------------- Rs[rbg:Rs[֎~
		bit1     : 0 ----------------- I[fBIf[^
		bit0     : 0 ----------------- p
*/
#define SPDIF_ChannelStatusLch 0x22800000	/* 48kHz fs */
#define SPDIF_ChannelStatusRch 0x22400000	/* 48kHz fs */
//#define SPDIF_ChannelStatusLch 0x20800000	/* 44.1kHz fs */
//#define SPDIF_ChannelStatusRch 0x20400000	/* 44.1kHz fs */
//#define SPDIF_ChannelStatusLch 0x23800000	/* 32kHz fs */
//#define SPDIF_ChannelStatusRch 0x23400000	/* 32kHz fs */

//#define PCM_BUFFER	0x1C010000
//#define PCM_BUFSIZE	0x000F0000

void main(void)
{
	unsigned short i,l;
	unsigned long data;
	short Rdata, Ldata;
	unsigned short lev=0;
	unsigned short peak=0;
//	int *play, *rec;

	INTC.IBNR.WORD = 0x4000;

	/* |[gC8 o͐ݒ */
	PORT.PCDR0.BYTE.H |= 0x01u;		/* LED  */
	PORT.PCIOR0.WORD  |= 0x0100u;	/* PC8 o */
	PORT.PCCR2.BIT.PC8MD = 0;		/* PC8 GPIO */

	/* |[gG0-7 o͐ݒ */
	PORT.PGDR0.BYTE.L |= 0xFFu;		/* LED  */
	PORT.PGIOR0.WORD  |= 0x00FFu;	/* PG0-7 o */
	PORT.PGCR0.BIT.PG1MD = 0;		/* PG1 GPIO */
	PORT.PGCR0.BIT.PG2MD = 0;		/* PG2 GPIO */
	PORT.PGCR0.BIT.PG3MD = 0;		/* PG3 GPIO */
	PORT.PGCR1.BIT.PG4MD = 0;		/* PG4 GPIO */
	PORT.PGCR1.BIT.PG5MD = 0;		/* PG5 GPIO */
	PORT.PGCR1.BIT.PG6MD = 0;		/* PG6 GPIO */
	PORT.PGCR1.BIT.PG7MD = 0;		/* PG7 GPIO */

	/* SPDIF_ENM = 'H' A PeakI[o[ */
	PORT.PCDR0.BYTE.L |= 0x24u;		/* SPDIF_EN 'H' */
	PORT.PCIOR0.WORD  |= 0x0024u;	/* PC2 o */
	PORT.PCCR0.BIT.PC2MD = 0;		/* PC2 GPIO */
	PORT.PCCR1.BIT.PC5MD = 0;		/* PC5 GPIO */
	
	/* AUDIO_CLK(PE0) */
	PORT.PECR0.BIT.PE0MD = 2;		/* AUDIO_CLK */

	/* SPDIFMI */
	PORT.PFCR2.BIT.PF11MD = 5;		/* SPDIF_IN I */
	PORT.PFCR3.BIT.PF12MD = 5;		/* SPDIF_OUTI */

	/* SPDIF */
	CPG.STBCR7.BIT.MSTP76 = 0;		/* SPDIFCl[u */

	SPDIF.TLCS.LONG = SPDIF_ChannelStatusLch;
	SPDIF.TRCS.LONG = SPDIF_ChannelStatusRch;
	SPDIF.TUI  = 0;
	SPDIF.TLCA = 0x0000;	/* L ch f[^ */
	SPDIF.TRCA = 0x0000;	/* R ch f[^ */

	SPDIF.CTRL.LONG =
//				  (1<<28) | /* AUDIO_CLK */
				  (1<<19) | /* NCSI */
				  (1<<17) | /* MCl[u */
				  (1<<16);  /* MCl[u */

	for(;;){

		if (SPDIF.STAT.BIT.CBRX) {	/* Mobt@t */
			Ldata = SPDIF.RLCA;	/* L ch f[^ */
			Rdata = SPDIF.RRCA;	/* R ch f[^ */
			data = (Ldata << 16) | Rdata;
			i++;
		}

		lev = abs( Ldata );
		lev += (unsigned short)( abs( Rdata ) );
		if( lev > peak ) peak = lev;
		if( (i>>10)&0x01 ) level( &lev, &peak );
		if (i > (48000/2)) {
			i = 0;
			l++;
			peak=0;
		}
		if (l&1) PORT.PCDR0.BYTE.H |= 0x01u;		/* LED  */
		else     PORT.PCDR0.BYTE.H &= 0xFEu;		/* LED _ */
	}

}

void level(unsigned short *lev,unsigned short *peak ){
	char led;
	
	if( *lev < 0x000F ){
		led = 0xFF;
	}else if( *lev <= 0x003F ){
		led = 0x7F;
	}else if( *lev <= 0x00FF ){
		led = 0x3F;
	}else if( *lev <= 0x03FF ){
		led = 0x1F;
	}else if( *lev <= 0x0FFF ){
		led = 0x0F;
	}else if( *lev <= 0x3FFF ){
		led = 0x07;
	}else if( *lev <= 0x7FFF ){
		led = 0x03;
	}else if( *lev <= 0xFFFF ){
		led = 0x01;
	}else{
		led = 0x00;
	}
	PORT.PCDR0.BYTE.L |= 0x20u;
	if( *peak < 0x000F ){
		;
	}else if( *peak <= 0x000F ){
		led &= 0x7F;
	}else if( *peak <= 0x003F ){
		led &= 0xBF;
	}else if( *peak <= 0x00FF ){
		led &= 0xDF;
	}else if( *peak <= 0x03FF ){
		led &= 0xEF;
	}else if( *peak <= 0x0FFF ){
		led &= 0xF7;
	}else if( *peak <= 0x3FFF ){
		led &= 0xFB;
	}else if( *peak <= 0x7FFF ){
		led &= 0xFD;
	}else if( *peak <= 0xFFFF ){
		led &= 0xFE;
	}else{
		PORT.PCDR0.BYTE.L &= 0xDFu;
	}	
	PORT.PGDR0.BYTE.L = led;
}

#ifdef __cplusplus
void abort(void)
{

}
#endif
